function [th,P,lam]=covfun2ar(R,n);
%Estimate parameters in an auto-regressive model
Rbar=toeplitz(R(1:n),R(1:n));
fbar=-R(2:n+1);   % Rhatyy(1) to Rhatyy(n)
th=Rbar\fbar;     % Solution to Yule-Walker equations
Rsym = [R(end-1:-1:2)' R(1:end)']'; % Symmetric covfun
Ree = filtfilt([1 ;th],1,Rsym);     % Inverse super formula
[Rmax,~] = max(Ree);
lam = Rmax;
P=lam*inv(Rbar); 